## mpi4py 4.0.3

=== CMakeLists.txt ===
# Author:  Lisandro Dalcin
# Contact: dalcinl@gmail.com
cmake_minimum_required(VERSION 3.15...3.26)

project(mpi4py LANGUAGES C)

find_package(
  Python REQUIRED
  COMPONENTS Interpreter
  COMPONENTS Development.Module
  OPTIONAL_COMPONENTS Development.Embed
)

find_package(MPI REQUIRED)
separate_arguments(MPI_C_COMPILE_OPTIONS NATIVE_COMMAND)
separate_arguments(MPI_C_LINK_FLAGS NATIVE_COMMAND)

set(CIBUILDWHEEL $<BOOL:$ENV{CIBUILDWHEEL}>)
add_compile_definitions($<${CIBUILDWHEEL}:CIBUILDWHEEL=1>)

include(CheckSymbolExists)
set(CMAKE_REQUIRED_INCLUDES ${MPI_C_INCLUDE_DIRS})
set(CMAKE_REQUIRED_DEFINITIONS ${MPI_C_COMPILE_DEFINITIONS})
set(CMAKE_REQUIRED_FLAGS ${MPI_C_COMPILE_OPTIONS})


set(BINDIR ${CMAKE_CURRENT_BINARY_DIR})
set(TOPDIR ${CMAKE_CURRENT_SOURCE_DIR})
set(SRCDIR ${CMAKE_CURRENT_SOURCE_DIR}/src)


# Cython
set(cythonize ${TOPDIR}/conf/cythonize.py)
set(Cython_COMMAND ${Python_EXECUTABLE} ${cythonize})
set(Cython_OPTIONS --3str --cleanup 3)
set(MPI.pyx ${SRCDIR}/mpi4py/MPI.pyx)
file(
  GLOB_RECURSE MPI.deps
  ${SRCDIR}/mpi4py/*.pyx
  ${SRCDIR}/mpi4py/*.pxd
  ${SRCDIR}/mpi4py/MPI.src/*.pyx
  ${SRCDIR}/mpi4py/MPI.src/*.pxi
)
set(MPI.c ${BINDIR}/MPI.c)
set(MPI.h ${BINDIR}/MPI.h ${BINDIR}/MPI_api.h)
add_custom_command(
  OUTPUT ${MPI.c}
  BYPRODUCTS ${MPI.h}
  DEPENDS ${MPI.deps}
  WORKING_DIRECTORY ${TOPDIR}
  VERBATIM
  COMMAND
  ${Cython_COMMAND} ${Cython_OPTIONS}
  ${MPI.pyx} --output-file ${MPI.c}
)
install(FILES ${MPI.h} DESTINATION mpi4py)


# mpi4py.MPI
python_add_library(mpi4py.MPI MODULE ${MPI.c} WITH_SOABI)
set_target_properties(mpi4py.MPI PROPERTIES OUTPUT_NAME "MPI" PREFIX "")
target_include_directories(mpi4py.MPI PRIVATE ${SRCDIR})
target_include_directories(mpi4py.MPI PRIVATE ${MPI_C_INCLUDE_DIRS})
target_compile_definitions(mpi4py.MPI PRIVATE ${MPI_C_COMPILE_DEFINITIONS})
target_compile_options(mpi4py.MPI PRIVATE ${MPI_C_COMPILE_OPTIONS})
target_link_directories(mpi4py.MPI PRIVATE ${MPI_C_LIBRARY_DIRS})
target_link_libraries(mpi4py.MPI PRIVATE ${MPI_C_LIBRARIES})
target_link_options(mpi4py.MPI PRIVATE ${MPI_C_LINK_FLAGS})
install(TARGETS mpi4py.MPI LIBRARY DESTINATION mpi4py)


# mpi4py/bin/python-mpi
if (Python_Development.Embed_FOUND)
add_executable(python-mpi ${SRCDIR}/python.c)
target_include_directories(python-mpi PRIVATE ${Python_INCLUDE_DIRS})
target_link_directories(python-mpi PRIVATE ${Python_LIBRARY_DIRS})
target_link_libraries(python-mpi PRIVATE ${Python_LIBRARIES})
target_include_directories(python-mpi PRIVATE ${MPI_C_INCLUDE_DIRS})
target_compile_definitions(python-mpi PRIVATE ${MPI_C_COMPILE_DEFINITIONS})
target_compile_options(python-mpi PRIVATE ${MPI_C_COMPILE_OPTIONS})
target_link_directories(python-mpi PRIVATE ${MPI_C_LIBRARY_DIRS})
target_link_libraries(python-mpi PRIVATE ${MPI_C_LIBRARIES})
target_link_options(python-mpi PRIVATE ${MPI_C_LINK_FLAGS})
install(TARGETS python-mpi RUNTIME DESTINATION mpi4py/bin)
endif()


# mpi4py/*
file(
  GLOB mpi4py_SOURCES
  RELATIVE ${SRCDIR}
  ${SRCDIR}/mpi4py/*.py
  ${SRCDIR}/mpi4py/futures/*.py
  ${SRCDIR}/mpi4py/util/*.py
)
file(
  GLOB mpi4py_HEADERS
  RELATIVE ${SRCDIR}
  ${SRCDIR}/mpi4py/*.pxd
  ${SRCDIR}/mpi4py/include/mpi4py/*.[hi]
  ${SRCDIR}/mpi4py/include/mpi4py/*.px[di]
)
if (Python_VERSION VERSION_GREATER_EQUAL 3.11)
  list(APPEND mpi4py_HEADERS mpi4py/py.typed)
  list(APPEND mpi4py_HEADERS mpi4py/MPI.pyi)
  foreach(file ${mpi4py_SOURCES})
    list(APPEND mpi4py_HEADERS ${file}i)
  endforeach()
endif()
foreach(file ${mpi4py_SOURCES} ${mpi4py_HEADERS})
  get_filename_component(dir ${file} DIRECTORY)
  install(FILES ${SRCDIR}/${file} DESTINATION ${dir})
endforeach()

if (WIN32)
  set(mpidllpath mpi.pth)
  foreach(file ${mpidllpath})
    if (EXISTS ${SRCDIR}/${file})
      install(FILES ${SRCDIR}/${file} DESTINATION .)
    endif()
  endforeach()
endif()

=== debian/changelog ===
mpi4py (4.0.3-3ubuntu3) resolute; urgency=medium

  * No-change rebuild with Python 3.14 as supported version

 -- Graham Inggs <ginggs@ubuntu.com>  Mon, 20 Oct 2025 14:15:49 +0000

mpi4py (4.0.3-3ubuntu2) questing; urgency=medium

  * Backport upstream patch to fix build with Sphinx 8.2 (LP: #2113468).

 -- Dmitry Shachnev <mitya57@ubuntu.com>  Sun, 08 Jun 2025 22:54:55 +0300

mpi4py (4.0.3-3ubuntu1) plucky; urgency=medium

  * Merge with Debian; remaining chamges:
    - Restore test_pack skipping in skip_failing_tests_32bit_mpich.patch

 -- Matthias Klose <doko@ubuntu.com>  Sat, 15 Mar 2025 13:07:02 +0100

mpi4py (4.0.3-3) unstable; urgency=medium

  * skip spawn tests with OpenMPI. See Bug#1100120
  * avoid network-related (OPAL/libucs) tests errors by setting
    OMPI_MCA_btl_tcp_if_include=lo. Again, see Bug#1100120

 -- Drew Parsons <dparsons@debian.org>  Tue, 11 Mar 2025 23:03:55 +0100

mpi4py (4.0.3-2) unstable; urgency=medium

  * skip failing tests triggering a PMIX error in OpenMPI builds,
    to work around Bug#1098576
    - in test_util_pkl5: testIMProbe, testISSendAndRecv,
      testISSendCancel, testMessageProbeIProbe, testMProbe, testProbe,
      testTestAll, testGetStatusAll, testWaitAll
    - also test_util_pool: test_apply, test_async_error_callback,
      test_empty_iterable, test_imap, test_istarmap, test_map,
      test_pool_worker_lifetime_early_close, test_starmap,
      test_starmap_async
    - test_util_sync: testAcquireFree, testFree, testWaitForNotify,
      testWaitNotify, testDefault, testIter, testRoot, testNext,
      testStart, testTypechar, testStep, testAcquireRelease,
      testExclusion, testFairness, testAcquireNonblocking,
      test_unsupported_args, testWith, testValue, testBeginEnd
    - test_win: testAttributes, testCreateFlavor, testGetGroup,
      testGetAttr, testGetSetErrhandler, testGetSetInfo, testMemory,
      test_terminate, testGetSetName, testPyProps, testPickle,
      testSharedQuery, testAttachDetach

 -- Drew Parsons <dparsons@debian.org>  Tue, 11 Mar 2025 14:57:09 +0100

mpi4py (4.0.3-1ubuntu2) plucky; urgency=medium

  * No-change rebuild with Python 3.13 only

 -- Graham Inggs <ginggs@ubuntu.com>  Tue, 04 Mar 2025 17:39:25 +0000

mpi4py (4.0.3-1ubuntu1) plucky; urgency=medium

  * Merge with Debian Unstable. Remaining changes:
    - Restore test_pack skipping in skip_failing_tests_32bit_mpich.patch

 -- Simon Quigley <tsimonq2@ubuntu.com>  Wed, 19 Feb 2025 20:16:10 -0600

mpi4py (4.0.3-1) unstable; urgency=medium

  * New upstream release

 -- Drew Parsons <dparsons@debian.org>  Sat, 15 Feb 2025 21:59:12 +0100

mpi4py (4.0.1-7) unstable; urgency=medium

  * drop DMA test skips. PMIX errors in bigendian (s390x) fixed by
    prrte patch in openmpi 5.0.6-1 (see Bug#1087800)

 -- Drew Parsons <dparsons@debian.org>  Fri, 03 Jan 2025 23:18:53 +0100

mpi4py (4.0.1-6ubuntu1) plucky; urgency=medium

  * Merge with Debian; remaining changes:
    - Restore test_pack skipping in skip_failing_tests_32bit_mpich.patch

 -- Adrien Nader <adrien.nader@canonical.com>  Fri, 29 Nov 2024 17:44:01 +0100

mpi4py (4.0.1-3ubuntu2) plucky; urgency=medium

  * No-change rebuild for openmpi soname change.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 30 Nov 2024 07:13:34 +0100

mpi4py (4.0.1-3ubuntu1) plucky; urgency=medium

  * Merge with Debian; remaining changes:
    - Restore test_pack skipping in skip_failing_tests_32bit_mpich.patch
  * Add armhf and s390x to the list of architectures to ignore test results.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 18 Nov 2024 09:22:46 +0100

=== debian/control ===
Source: mpi4py
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Drew Parsons <dparsons@debian.org>,
           Yaroslav Halchenko <debian@onerussian.com>,
           Michael Hanke <michael.hanke@gmail.com>,
Section: python
Priority: optional
Build-Depends: debhelper-compat (= 13),
               dh-sequence-python3,
               mpi-default-dev,
               mpi-default-bin,
               openssh-client,
               cython3,
               python3-all-dev,
               python3-numpy,
               python3-sphinx,
               python3-setuptools
Build-Depends-Indep: texinfo, texlive,
 latexmk, tex-gyre,
 texlive-latex-extra,
 python3-doc,
 python-numpy-doc
Standards-Version: 4.7.0
Vcs-Browser: https://salsa.debian.org/science-team/mpi4py
Vcs-Git: https://salsa.debian.org/science-team/mpi4py.git
Homepage: https://github.com/mpi4py/mpi4py
Rules-Requires-Root: no

Package: python3-mpi4py
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         ${python3:Depends},
         mpi-default-bin
Suggests: python3-numpy
Breaks:  python3-pyzoltan (<< 1.0.1-10~)
Description: bindings of the Message Passing Interface (MPI) standard
 MPI for Python (mpi4py) provides bindings of the Message Passing
 Interface (MPI) standard for the Python programming language,
 allowing any Python program to exploit multiple processors.
 .
 mpi4py is constructed on top of the MPI-1/MPI-2 specification
 and provides an object oriented interface which closely follows MPI-2
 C++ bindings.  It supports point-to-point (sends, receives) and
 collective (broadcasts, scatters, gathers) communications of any
 picklable Python object as well as optimized communications of Python
 object exposing the single-segment buffer interface (NumPy arrays,
 builtin bytes/string/array objects).

Package: python-mpi4py-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends},
         ${sphinxdoc:Depends}
Suggests: python3-mpi4py
Description: bindings of the MPI standard -- documentation
 MPI for Python (mpi4py) provides bindings of the Message Passing
 Interface (MPI) standard for the Python programming language,
 allowing any Python program to exploit multiple processors.
 .
 mpi4py is constructed on top of the MPI-1/MPI-2 specification
 and provides an object oriented interface which closely follows MPI-2
 C++ bindings.  It supports point-to-point (sends, receives) and
 collective (broadcasts, scatters, gathers) communications of any
 picklable Python object as well as optimized communications of Python
 object exposing the single-segment buffer interface (NumPy arrays,
 builtin bytes/string/array objects).
 .
 This package provides HTML rendering of the user's manual.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)

# define ARCH_DEFAULT_MPI_IMPL
include /usr/share/mpi-default-dev/debian_defaults

PY3DEF = $(shell py3versions -vd)
PY3VERS = $(shell py3versions -vs)

LAST_CHANGE = $(shell dpkg-parsechangelog -S Date)
BUILD_DATE  = $(shell LC_ALL=C date -u "+%B %d, %Y" -d "$(LAST_CHANGE)")

export PRTE_MCA_rmaps_default_mapping_policy=:oversubscribe

# avoid network-related (OPAL/libucs) errors, see Bug#1100120
export OMPI_MCA_btl_tcp_if_include=lo

# Specify a specific version of MPI to use in the build, otherwise
# just use the default.
# MPI=.openmpi

export  http_proxy=http://127.0.0.1:9/
export  https_proxy=http://127.0.0.1:9/


# disable build tests for these arches:
# x32 consistently times out on tests
NO_TEST_ARCH_LIST = x32

empty :=
space := $(empty)$(empty)

# run tests, or not
RUNTEST=yes
ifneq (,$(findstring $(space)$(DEB_HOST_ARCH)$(space), $(space)$(NO_TEST_ARCH_LIST)$(space)))
  RUNTEST=no
endif
ifneq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
  RUNTEST=no
endif

ifeq ($(DEB_HOST_ARCH),mips64el)
# mips64el times out. Run tests on default python only.
    PY3VERS_TESTS = $(PY3DEF)
else
    PY3VERS_TESTS = $(PY3VERS)
endif

# hurd fails a couple of tests
# but hell, hurd needs all the help it can get, so let it pass
ARCH_IGNORE_FAILED_TESTS = hurd-i386

# normally, do not ignore test failures
IGNORE_FAILED_TESTS=/bin/false
ifneq (,$(findstring $(space)$(DEB_HOST_ARCH)$(space), $(space)$(ARCH_IGNORE_FAILED_TESTS)$(space)))
  IGNORE_FAILED_TESTS=/bin/true
endif

# OpenMPI is triggering both PMIX and spawn errors
CHECK_OPENMPI = $(MPI) $(ARCH_DEFAULT_MPI_IMPL)
ifneq (,$(findstring $(space)openmpi$(space), $(space)$(CHECK_OPENMPI)$(space)))
  # OpenMPI is triggering spawn errors
  # see Bug#1100120
  SKIP_TEST_LIST += test_spawn

  # OpenMPI is triggering PMIX errors in test_util_pkl5,  test_util_pool, test_util_sync and test_win
  # see Bug#1098576
  SKIP_TEST_LIST += test_util_pkl5.TestMPISelf.testIMProbe test_util_pkl5.TestMPISelf.testISSendAndRecv \
    test_util_pkl5.TestMPISelf.testISSendCancel test_util_pkl5.TestMPISelf.testMessageProbeIProbe \
    test_util_pkl5.TestMPISelf.testMProbe test_util_pkl5.TestMPISelf.testProbe \
    test_util_pkl5.TestMPISelf.testTestAll \
    test_util_pkl5.TestMPISelf.testGetStatusAll test_util_pkl5.TestMPISelf.testWaitAll \
    test_util_pkl5.TestMPIWorld.testIMProbe test_util_pkl5.TestMPIWorld.testISSendAndRecv \
    test_util_pkl5.TestMPIWorld.testISSendCancel test_util_pkl5.TestMPIWorld.testMessageProbeIProbe \
    test_util_pkl5.TestMPIWorld.testMProbe test_util_pkl5.TestMPIWorld.testProbe \
    test_util_pkl5.TestMPIWorld.testTestAll \
    test_util_pkl5.TestMPIWorld.testGetStatusAll  test_util_pkl5.TestMPIWorld.testWaitAll \
    test_util_pkl5.TestPKL5Self.testIMProbe test_util_pkl5.TestPKL5Self.testISSendAndRecv \
    test_util_pkl5.TestPKL5Self.testISSendCancel test_util_pkl5.TestPKL5Self.testMessageProbeIProbe \
    test_util_pkl5.TestPKL5Self.testMProbe test_util_pkl5.TestPKL5Self.testProbe \
    test_util_pkl5.TestPKL5Self.testTestAll \
    test_util_pkl5.TestPKL5Self.testGetStatusAll test_util_pkl5.TestPKL5Self.testWaitAll \
    test_util_pkl5.TestPKL5World.testIMProbe test_util_pkl5.TestPKL5World.testISSendAndRecv \
    test_util_pkl5.TestPKL5World.testISSendCancel test_util_pkl5.TestPKL5World.testMessageProbeIProbe \
    test_util_pkl5.TestPKL5World.testMProbe test_util_pkl5.TestPKL5World.testProbe \
    test_util_pkl5.TestPKL5World.testTestAll \
    test_util_pkl5.TestPKL5World.testGetStatusAll test_util_pkl5.TestPKL5World.testWaitAll \
    test_util_pool.TestProcessPool.test_apply test_util_pool.TestProcessPool.test_async_error_callback \
    test_util_pool.TestProcessPool.test_empty_iterable test_util_pool.TestProcessPool.test_imap \
    test_util_pool.TestProcessPool.test_istarmap test_util_pool.TestProcessPool.test_map \
    test_util_pool.TestProcessPool.test_pool_worker_lifetime_early_close \
    test_util_pool.TestProcessPool.test_starmap \
    test_util_pool.TestThreadPool.test_unsupported_arg test_util_pool.TestThreadPool.test_starmap_async \
    test_util_sync.TestConditionMutexSelf.testAcquireFree test_util_sync.TestConditionMutexSelf.testFree \
    test_util_sync.TestConditionMutexSelf.testWaitForNotify test_util_sync.TestConditionMutexSelf.testWaitNotify \
    test_util_sync.TestConditionMutexWorld.testAcquireFree test_util_sync.TestConditionMutexWorld.testFree \
    test_util_sync.TestConditionMutexWorld.testWaitForNotify test_util_sync.TestConditionMutexWorld.testWaitNotify \
    test_util_sync.TestConditionSelf.testAcquireFree test_util_sync.TestConditionSelf.testFree \
    test_util_sync.TestConditionSelf.testWaitForNotify test_util_sync.TestConditionSelf.testWaitNotify \
    test_util_sync.TestConditionWorld.testAcquireFree test_util_sync.TestConditionWorld.testFree \
    test_util_sync.TestConditionWorld.testWaitForNotify test_util_sync.TestConditionWorld.testWaitNotify \
    test_util_sync.TestCounterSelf.testDefault test_util_sync.TestCounterSelf.testIter \
    test_util_sync.TestCounterSelf.testFree test_util_sync.TestCounterSelf.testRoot \
    test_util_sync.TestCounterSelf.testNext test_util_sync.TestCounterSelf.testStart \
    test_util_sync.TestCounterSelf.testTypechar test_util_sync.TestCounterSelf.testStep \
    test_util_sync.TestCounterWorld.testDefault test_util_sync.TestCounterWorld.testIter \
    test_util_sync.TestCounterWorld.testFree test_util_sync.TestCounterWorld.testRoot \
    test_util_sync.TestCounterWorld.testNext test_util_sync.TestCounterWorld.testStart \
    test_util_sync.TestCounterWorld.testTypechar test_util_sync.TestCounterWorld.testStep \
    test_util_sync.TestMutexBasicSelf.testAcquireFree test_util_sync.TestMutexBasicSelf.testFree \
    test_util_sync.TestMutexBasicSelf.testWaitForNotify test_util_sync.TestMutexBasicSelf.testWaitNotify \
    test_util_sync.TestMutexBasicSelf.testAcquireRelease test_util_sync.TestMutexBasicSelf.testExclusion \
    test_util_sync.TestMutexBasicSelf.testFairness test_util_sync.TestMutexBasicSelf.testAcquireNonblocking \
    test_util_sync.TestMutexBasicSelf.testWith \
    test_util_sync.TestMutexBasicWorld.testAcquireFree test_util_sync.TestMutexBasicWorld.testFree \
    test_util_sync.TestMutexBasicWorld.testWaitForNotify test_util_sync.TestMutexBasicWorld.testWaitNotify \
    test_util_sync.TestMutexBasicWorld.testAcquireRelease test_util_sync.TestMutexBasicWorld.testExclusion \
    test_util_sync.TestMutexBasicWorld.testFairness test_util_sync.TestMutexBasicWorld.testAcquireNonblocking \
    test_util_sync.TestMutexBasicWorld.testWith \
    test_util_sync.TestMutexRecursiveSelf.testAcquireFree test_util_sync.TestMutexRecursiveSelf.testFree \
    test_util_sync.TestMutexRecursiveSelf.testWaitForNotify test_util_sync.TestMutexRecursiveSelf.testWaitNotify \
    test_util_sync.TestMutexRecursiveSelf.testAcquireRelease test_util_sync.TestMutexRecursiveSelf.testExclusion \
    test_util_sync.TestMutexRecursiveSelf.testFairness test_util_sync.TestMutexRecursiveSelf.testAcquireNonblocking \
    test_util_sync.TestMutexRecursiveSelf.testWith \
    test_util_sync.TestMutexRecursiveWorld.testAcquireFree test_util_sync.TestMutexRecursiveWorld.testFree \
    test_util_sync.TestMutexRecursiveWorld.testWaitForNotify test_util_sync.TestMutexRecursiveWorld.testWaitNotify \
    test_util_sync.TestMutexRecursiveWorld.testAcquireRelease test_util_sync.TestMutexRecursiveWorld.testExclusion \
    test_util_sync.TestMutexRecursiveWorld.testFairness test_util_sync.TestMutexRecursiveWorld.testAcquireNonblocking \
    test_util_sync.TestMutexRecursiveWorld.testWith \
    test_util_sync.TestSemaphoreSelf.testAcquireFree test_util_sync.TestSemaphoreSelf.testFree \
    test_util_sync.TestSemaphoreSelf.testWaitForNotify test_util_sync.TestSemaphoreSelf.testWaitNotify \

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
 https://github.com/mpi4py/mpi4py/tags \
 (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate

## mpi4py 4.1.0

=== demo/wrap-nanobind/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.15...3.27)
project(helloworld)

if (CMAKE_VERSION VERSION_LESS 3.18)
  set(DEV_MODULE Development)
else()
  set(DEV_MODULE Development.Module)
endif()

set(Python_FIND_UNVERSIONED_NAMES FIRST)
find_package(Python 3.8 COMPONENTS Interpreter ${DEV_MODULE} REQUIRED)

find_package(MPI REQUIRED)

execute_process(
  COMMAND "${Python_EXECUTABLE}" -m mpi4py --prefix
  OUTPUT_STRIP_TRAILING_WHITESPACE
  OUTPUT_VARIABLE mpi4py_ROOT
)
set(mpi4py_INCLUDE ${mpi4py_ROOT}/include)

execute_process(
  COMMAND "${Python_EXECUTABLE}" -m nanobind --cmake_dir
  OUTPUT_STRIP_TRAILING_WHITESPACE
  OUTPUT_VARIABLE nanobind_ROOT
)
find_package(nanobind CONFIG REQUIRED)

if (NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  set(CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build." FORCE)
  set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug" "Release" "MinSizeRel" "RelWithDebInfo")
endif()

nanobind_add_module(helloworld helloworld.cxx)
target_include_directories(helloworld PRIVATE ${mpi4py_INCLUDE})
target_include_directories(helloworld PRIVATE MPI::MPI_C)
target_link_libraries(helloworld PRIVATE MPI::MPI_C)
install(TARGETS helloworld LIBRARY DESTINATION .)

=== debian/changelog ===
mpi4py (4.1.0-9) unstable; urgency=medium

  * build on sh4 with -mno-lra (see Bug#1116453)

 -- Drew Parsons <dparsons@debian.org>  Sat, 27 Sep 2025 15:54:33 +0200

mpi4py (4.1.0-8) unstable; urgency=medium

  * more updates to skip_failing_tests_PR690.patch

 -- Drew Parsons <dparsons@debian.org>  Wed, 24 Sep 2025 17:11:35 +0200

mpi4py (4.1.0-7) unstable; urgency=medium

  * update skip_failing_tests_PR690.patch for ppc64

 -- Drew Parsons <dparsons@debian.org>  Wed, 24 Sep 2025 16:02:09 +0200

mpi4py (4.1.0-6) unstable; urgency=medium

  * debian patch skip_failing_tests_PR690.patch applies upstream PR#690
    amalgamating all debian test skips.

 -- Drew Parsons <dparsons@debian.org>  Tue, 23 Sep 2025 21:56:00 +0200

mpi4py (4.1.0-5) unstable; urgency=medium

  * debian patch skip_mpich_universesize.patch skips testUniverseSize
    in test_environ.py with mpich (<5). See upstream Issue#679.

 -- Drew Parsons <dparsons@debian.org>  Tue, 02 Sep 2025 16:53:00 +0200

mpi4py (4.1.0-4) unstable; urgency=medium

  * Team upload.
  * Replace doc_sphinx8.1_revert_PR629.patch with another patch, that
    makes the package build fine with both Sphinx 8.1 and 8.2.

 -- Dmitry Shachnev <mitya57@debian.org>  Mon, 25 Aug 2025 21:42:59 +0300

mpi4py (4.1.0-3) unstable; urgency=medium

  * Standards-Version: 4.7.2

 -- Drew Parsons <dparsons@debian.org>  Sun, 10 Aug 2025 11:02:26 +0200

mpi4py (4.1.0-2) experimental; urgency=medium

  * skip testContiguousBigMPI on 32-bit systems.
    See https://github.com/mpi4py/mpi4py/issues/670

 -- Drew Parsons <dparsons@debian.org>  Thu, 31 Jul 2025 14:59:02 +0200

mpi4py (4.1.0-1) experimental; urgency=medium

  * New upstream release
  * build with MPI4PY_BUILD_MPIABI=1 to enable enhanced support for
    the MPI 5.0 standard ABI and the MPICH or Open MPI legacy ABIs
    Common ABI enables cross-support between OpenMPI and mpich,
    so Closes: #694307.
  * Build-Depends: pybuild-plugin-pyproject
    to build via pyproject.toml
  * update debian/rules
    - drop dh_auto_build override, use default mpicc wrapper
    - build docs before dh_auto_install, to ensure dh_auto_build has
      already been run
    - replace redundant overrides with execute_after_
    - remove redundant get-orig-dev-source
      (upstream now uses github not mercury hg for source repo)
  * debian patch doc_sphinx8.1_revert_PR629.patch reverts upstream
    PR#629 to enable doc build with sphinx 8.1.3.
    See upstream Issue#668.

 -- Drew Parsons <dparsons@debian.org>  Wed, 23 Jul 2025 11:22:51 +0200

mpi4py (4.0.3-4) unstable; urgency=medium

  * reenable PMIx tests. The problem is resolved (Bug#1098576).

 -- Drew Parsons <dparsons@debian.org>  Thu, 27 Mar 2025 21:20:49 +0100

=== debian/tests/control ===
Tests: mpi4py-test
Depends: python3-mpi4py,
    mpi-default-dev,
    python3-all,
    python3-cffi,
    python3-dill,
    python3-setuptools,
    python3-numpy,
    python3-simplejson,
    python3-yaml
Restrictions: allow-stderr


# Dummy test so that changes to other packages
# trigger our autopkgtests on ci.debian.net
Test-Command: /bin/true
Depends: libpmix-dev,
    libucx-dev [amd64 arm64 ppc64el],
Restrictions: hint-testsuite-triggers

## mpi4py 4.1.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,22 +1,39 @@
 # Author:  Lisandro Dalcin
 # Contact: dalcinl@gmail.com
 cmake_minimum_required(VERSION 3.15...3.26)
+project(mpi4py LANGUAGES C)
 
-project(mpi4py LANGUAGES C)
+set(
+  MPIABI $ENV{MPI4PY_BUILD_MPIABI} CACHE BOOL
+  "Use MPI ABI (standard or legacy)"
+)
+set(
+  PYSABI $ENV{MPI4PY_BUILD_PYSABI} CACHE STRING
+  "Use Python Stable ABI"
+)
+
+if (PYSABI)
+  if (NOT SKBUILD_SABI_COMPONENT)
+    set(SKBUILD_SABI_COMPONENT Development.SABIModule)
+  endif()
+  if (NOT SKBUILD_SABI_VERSION)
+    set(SKBUILD_SABI_VERSION ${PYSABI})
+  endif()
+endif()
+if (SKBUILD_SABI_VERSION)
+  set(WITH_SABI USE_SABI ${SKBUILD_SABI_VERSION})
+endif()
 
 find_package(
   Python REQUIRED
   COMPONENTS Interpreter
-  COMPONENTS Development.Module
+  COMPONENTS Development.Module ${SKBUILD_SABI_COMPONENT}
   OPTIONAL_COMPONENTS Development.Embed
 )
 
 find_package(MPI REQUIRED)
 separate_arguments(MPI_C_COMPILE_OPTIONS NATIVE_COMMAND)
 separate_arguments(MPI_C_LINK_FLAGS NATIVE_COMMAND)
-
-set(CIBUILDWHEEL $<BOOL:$ENV{CIBUILDWHEEL}>)
-add_compile_definitions($<${CIBUILDWHEEL}:CIBUILDWHEEL=1>)
 
 include(CheckSymbolExists)
 set(CMAKE_REQUIRED_INCLUDES ${MPI_C_INCLUDE_DIRS})
@@ -57,8 +74,9 @@
 
 
 # mpi4py.MPI
-python_add_library(mpi4py.MPI MODULE ${MPI.c} WITH_SOABI)
+python_add_library(mpi4py.MPI MODULE ${MPI.c} WITH_SOABI ${WITH_SABI})
 set_target_properties(mpi4py.MPI PROPERTIES OUTPUT_NAME "MPI" PREFIX "")
+target_compile_definitions(mpi4py.MPI PRIVATE $<$<BOOL:${MPIABI}>:PYMPIABI=1>)
 target_include_directories(mpi4py.MPI PRIVATE ${SRCDIR})
 target_include_directories(mpi4py.MPI PRIVATE ${MPI_C_INCLUDE_DIRS})
 target_compile_definitions(mpi4py.MPI PRIVATE ${MPI_C_COMPILE_DEFINITIONS})
@@ -100,7 +118,7 @@
   ${SRCDIR}/mpi4py/include/mpi4py/*.[hi]
   ${SRCDIR}/mpi4py/include/mpi4py/*.px[di]
 )
-if (Python_VERSION VERSION_GREATER_EQUAL 3.11)
+if (TRUE)
   list(APPEND mpi4py_HEADERS mpi4py/py.typed)
   list(APPEND mpi4py_HEADERS mpi4py/MPI.pyi)
   foreach(file ${mpi4py_SOURCES})
@@ -113,7 +131,7 @@
 endforeach()
 
 if (WIN32)
-  set(mpidllpath mpi.pth)
+  set(mpidllpath _mpi_dll_path.py mpi.pth)
   foreach(file ${mpidllpath})
     if (EXISTS ${SRCDIR}/${file})
       install(FILES ${SRCDIR}/${file} DESTINATION .)

=== debian/changelog ===
mpi4py (4.1.1-1) unstable; urgency=medium

  * New upstream release
    - applies debian patches doc_sphinx8.1_fix_PR629.patch
      and skip_failing_tests_PR690.patch

 -- Drew Parsons <dparsons@debian.org>  Fri, 24 Oct 2025 13:06:07 +0200

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: mpi4py
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
+Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Drew Parsons <dparsons@debian.org>,
            Yaroslav Halchenko <debian@onerussian.com>,
            Michael Hanke <michael.hanke@gmail.com>,
@@ -8,6 +7,7 @@
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
                dh-sequence-python3,
+               pybuild-plugin-pyproject,
                mpi-default-dev,
                mpi-default-bin,
                openssh-client,
@@ -21,7 +21,7 @@
  texlive-latex-extra,
  python3-doc,
  python-numpy-doc
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/science-team/mpi4py
 Vcs-Git: https://salsa.debian.org/science-team/mpi4py.git
 Homepage: https://github.com/mpi4py/mpi4py

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)

# define ARCH_DEFAULT_MPI_IMPL
include /usr/share/mpi-default-dev/debian_defaults

PY3DEF = $(shell py3versions -vd)
PY3VERS = $(shell py3versions -vs)

LAST_CHANGE = $(shell dpkg-parsechangelog -S Date)
BUILD_DATE  = $(shell LC_ALL=C date -u "+%B %d, %Y" -d "$(LAST_CHANGE)")

# enable enhanced support for the MPI 5.0 standard ABI and the MPICH or Open MPI legacy ABIs
export MPI4PY_BUILD_MPIABI=1

export PRTE_MCA_rmaps_default_mapping_policy=:oversubscribe

# avoid network-related (OPAL/libucs) errors, see Bug#1100120
export OMPI_MCA_btl_tcp_if_include=lo

ifeq ($(DEB_HOST_ARCH),sh4)
export DEB_CFLAGS_MAINT_APPEND = -mno-lra
endif

# Specify a specific version of MPI to use in the build, otherwise
# just use the default.
# MPI=.openmpi

export  http_proxy=http://127.0.0.1:9/
export  https_proxy=http://127.0.0.1:9/


# disable build tests for these arches:
# x32 consistently times out on tests
NO_TEST_ARCH_LIST = x32

empty :=
space := $(empty)$(empty)

# run tests, or not
RUNTEST=yes
ifneq (,$(findstring $(space)$(DEB_HOST_ARCH)$(space), $(space)$(NO_TEST_ARCH_LIST)$(space)))
  RUNTEST=no
endif
ifneq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
  RUNTEST=no
endif

ifeq ($(DEB_HOST_ARCH),mips64el)
# mips64el times out. Run tests on default python only.
    PY3VERS_TESTS = $(PY3DEF)
else
    PY3VERS_TESTS = $(PY3VERS)
endif

# hurd fails a couple of tests
# but hell, hurd needs all the help it can get, so let it pass
ARCH_IGNORE_FAILED_TESTS = hurd-i386

# normally, do not ignore test failures
IGNORE_FAILED_TESTS=/bin/false
ifneq (,$(findstring $(space)$(DEB_HOST_ARCH)$(space), $(space)$(ARCH_IGNORE_FAILED_TESTS)$(space)))
  IGNORE_FAILED_TESTS=/bin/true
endif

# OpenMPI is triggering both PMIX and spawn errors
CHECK_OPENMPI = $(MPI) $(ARCH_DEFAULT_MPI_IMPL)
ifneq (,$(findstring $(space)openmpi$(space), $(space)$(CHECK_OPENMPI)$(space)))
  # OpenMPI is triggering spawn errors
  # see Bug#1100120
  SKIP_TEST_LIST += test_spawn
endif

# failing RMA tests from test_rma_nb
SKIP_RMA_ACCUMULATE_ARCH_LIST = s390x ppc64 sparc64
ifneq (,$(findstring $(space)$(DEB_HOST_ARCH)$(space), $(space)$(SKIP_RMA_ACCUMULATE_ARCH_LIST)$(space)))
    SKIP_TEST_LIST += testAccumulate testGetAccumulate
endif

ifeq ($(DEB_HOST_ARCH),mips64el)
    SKIP_TEST_LIST += TestRMA
endif

ifeq ($(DEB_HOST_ARCH),sparc64)
    # OpenMPI broke memory alignment on sparc64, see https://github.com/mpi4py/mpi4py/issues/147
    SKIP_TEST_LIST += testPackUnpackExternal
endif

# testContiguousBigMPI fails on 32-bit systems
# https://github.com/mpi4py/mpi4py/issues/670
ifeq ($(DEB_HOST_ARCH_BITS),32)
    SKIP_TEST_LIST += testContiguousBigMPI
endif

%:
	dh $@ --with sphinxdoc --buildsystem pybuild

cythonize:
	@echo "D: removing previously generated by Cython sources"
	find -iname *.c | xargs grep -l 'Generated by Cython' | xargs -r rm
	python3 setup.py build_src

override_dh_autoreconf:
	dh_autoreconf debian/rules -- cythonize

execute_before_dh_auto_install-indep:
	PYTHONPATH=`pybuild -p $(PY3DEF) --print "{build_dir}"` \
	  make -C docs/source/ html man info latexpdf SPHINXOPTS="-D today=\"$(BUILD_DATE)\""

execute_after_dh_auto_install:
	: # Remove python-mpi binaries
	find $(CURDIR)/debian/tmp -name python-mpi -delete
	find $(CURDIR)/debian/tmp -type d -empty -delete

execute_after_dh_install-arch:
	: # create symlinks for .h files
	: # Can have python$$v symlink pointing to python3.?m or python3.?mu
	: # see #700995 for more details.  So first look where it points to
	: # and use that directory
	set -e; for v in $(PY3VERS); do \
	ABITAG=`python$$v -c "import sys; print(sys.abiflags)"`; \
	[ -d $(CURDIR)/debian/python3-mpi4py/usr/include/python$$v$$ABITAG ] || \
		mkdir -p $(CURDIR)/debian/python3-mpi4py/usr/include/python$$v$$ABITAG; \
		dh_link -ppython3-mpi4py usr/lib/python3/dist-packages/mpi4py/include/mpi4py usr/include/python$$v$$ABITAG/mpi4py; \
	done

override_dh_auto_test:
	set -e; \
	if [ "$(RUNTEST)" = "no" ]; then \
	  echo Build tests have been disabled; \
	else \
	SKIP_TESTS=""; \
	list_initialised=0; \
	for t in $(SKIP_TEST_LIST); do \
	    if [ $${list_initialised} = 0 ]; then \
	        SKIP_TESTS="-x $$t"; \
	        list_initialised=1; \
	    else \
	        SKIP_TESTS="$${SKIP_TESTS} -x $$t"; \
	    fi; \
	done; \
	echo "skipping tests: $${SKIP_TESTS}"; \
	  for vv in $(PY3VERS_TESTS); do \
	  echo "I: testing using python$$vv"; \
	   echo "I: running tests with single process"; \
	   PYTHONPATH=`pybuild -p $$vv --print "{build_dir}"` \
	    GITHUB_ACTIONS=true MPI4PY_TEST_SPAWN=false \
	    /usr/bin/python$$vv $(CURDIR)/test/runtests.py -v $${SKIP_TESTS} || $(IGNORE_FAILED_TESTS); \
	   nproc=`nproc`; MIN_PROC=$$(( nproc > 2 ? nproc : 2 )); \
	   NUM_PROC=$$(( MIN_PROC > 5 ? 5 : MIN_PROC )); \
	   echo "I: running tests with MPI ($$NUM_PROC processes)"; \
	   PYTHONPATH=`pybuild -p $$vv --print "{build_dir}"` \
	    GITHUB_ACTIONS=true MPI4PY_TEST_SPAWN=false \
	    mpirun -v -n $$NUM_PROC /usr/bin/python$$vv $(CURDIR)/test/runtests.py -fv $${SKIP_TESTS} || $(IGNORE_FAILED_TESTS); \
	  done; \
	fi

override_dh_sphinxdoc:
ifeq (,$(findstring nodoc,$(DEB_BUILD_OPTIONS)))
	dh_sphinxdoc -ppython-mpi4py-doc
endif

override_dh_installchangelogs:
	dh_installchangelogs CHANGES.rst

## Immediately useable documentation
override_dh_compress:
	dh_compress -X.py -X.html -X.css -X.jpg -X.txt -X.js -X.json -X.rtc -X.par -X.bin -Xobjects.inv -X.pdf

override_dh_dwz:
	echo "dh_dwz is currently deactivated since it generates an error: \".debug_line reference above end of section\""

execute_after_dh_auto_clean:
	rm -rf `find -name build -type d`
	rm -rf `find -name _build -type d`
	rm -rf docs/source/reference

	: # Remove Cython generated files
	rm -f src/mpi4py.MPE.c src/mpi4py.MPI.c src/include/mpi4py/mpi4py.MPI_api.h
